SystemOrganization addCategory: #MudTalk!
SystemOrganization addCategory: #'MudTalk-Client'!
SystemOrganization addCategory: #'MudTalk-Tests'!

Object subclass: #MudServer
	instanceVariableNames: 'started'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!MudServer methodsFor: 'initialize-release' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
initialize
	started := false.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
isStarted
	^ started.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:21'!
isStopped
	^ started not.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:32'!
start
	started := true.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:33'!
stop
	started := false.! !

Object subclass: #MudTalkClient
	instanceVariableNames: 'window inputPane outputPane outputContents connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/2/2013 18:17'!
connectTo: aHost port: aPort 
	connection := MudTalkClientConnection new connectTo: aHost port: aPort.! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/2/2013 20:49'!
disconnect
	connection ifNotNil: [ connection terminate ].! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:48'!
getInput
	^nil.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 18:10'!
host
	^ NetNameResolver addressFromString: '10.240.1.10'.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 19:59'!
initialize
	super initialize.
	self installInputPane.
	self installOutputPane.
	self initializeConnection.
	self window openInWorld.
	self inputPane takeKeyboardFocus.! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 21:13'!
initializeConnection
	self connectTo: self host port: self port.
	connection events when: #textReceived send: #textReceived: to: self! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 18:20'!
inputPane
	^ inputPane ifNil: [
		inputPane := self window newTextEditorFor: self getText: #getInput setText: #sendCommand:.
		inputPane acceptOnCR: true].! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 17:02'!
installInputPane
	self window
		addMorph: self inputPane
		fullFrame: (LayoutFrame fractions: (0@0.5 extent: 1@1)).! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 17:04'!
installOutputPane
	self window
		addMorph: self outputPane
		fullFrame: (LayoutFrame fractions: (0@0 extent: 1@0.5)).! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:39'!
outputContents
	^ outputContents ifNil: [
		outputContents := Text new].! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 17:39'!
outputPane
	^ outputPane ifNil: [
		outputPane := self window newTextEditorFor: self getText: #outputContents setText: nil].! !

!MudTalkClient methodsFor: 'outputting' stamp: 'AlexanderSvyazin 1/2/2013 17:52'!
outputText: aText
	self outputContents append: aText.
	self outputContents append: Character cr.
	self changed: #outputContents.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 18:05'!
port
	^ 10101.! !

!MudTalkClient methodsFor: 'updating' stamp: 'AlexanderSvyazin 1/2/2013 21:14'!
sendCommand: aText
	connection sendText: aText.
	self changed: #getInput.! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/2/2013 21:12'!
textReceived: line 
	self outputText: line asText.! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/2/2013 16:34'!
window
	^ window ifNil: [
		window := StandardWindow labelled: 'MUD client']! !

Object subclass: #MudTalkClientConnection
	instanceVariableNames: 'stream readingProcess events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientConnection methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/2/2013 20:48'!
connectTo: aHost port: aPort 
	stream := SocketStream openConnectionToHost: aHost port: aPort.
	readingProcess := [self networkReadLoop] forkNamed: 'MUD client network reading process'.! !

!MudTalkClientConnection methodsFor: 'events' stamp: 'AlexanderSvyazin 1/2/2013 20:58'!
events
	^ events ifNil: [
		events := EventManager new].! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/2/2013 20:46'!
networkReadLoop
	[self processLineFromServer] repeat.! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/2/2013 21:11'!
processLineFromServer
	|line|
	line := stream nextLine.
	self events triggerEvent: #textReceived with: line.! !

!MudTalkClientConnection methodsFor: 'write' stamp: 'AlexanderSvyazin 1/2/2013 21:19'!
sendText: aText
	stream nextPutAll: aText; crlf; flush.! !

!MudTalkClientConnection methodsFor: 'read' stamp: 'AlexanderSvyazin 1/2/2013 20:49'!
terminateReadingProcess
	readingProcess ifNotNil: [ readingProcess terminate ]! !

Object subclass: #TelnetParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
ao
	^ TelnetParser iac , TelnetParser aoChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
aoChar
	^ Character value: 245.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
ayt
	^ TelnetParser iac , TelnetParser aytChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
aytChar
	^ Character value: 246.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
brk
	^ TelnetParser iac , TelnetParser brkChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
brkChar
	^ Character value: 243.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
dm
	^ TelnetParser iac , TelnetParser dmChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
dmChar
	^ Character value: 242.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
do
	^ TelnetParser iac , TelnetParser doChar asParser , #any asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
doChar
	^ Character value: 253.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
dont
	^ TelnetParser iac , TelnetParser dontChar asParser , #any asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
dontChar
	^ Character value: 254.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
ec
	^ TelnetParser iac , TelnetParser ecChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
ecChar
	^ Character value: 247.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
el
	^ TelnetParser iac , TelnetParser elChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
elChar
	^ Character value: 248.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
ga
	^ TelnetParser iac , TelnetParser gaChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
gaChar
	^ Character value: 249.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
iac
	^ TelnetParser iacChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
iacChar
	^ Character value: 255.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
ip
	^ TelnetParser iac , TelnetParser ipChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
ipChar
	^ Character value: 244.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
nop
	^ TelnetParser iac , TelnetParser nopChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
nopChar
	^ Character value: 241.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
sb
	^ TelnetParser iac , TelnetParser sbChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
sbChar
	^ Character value: 250.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
se
	^ TelnetParser iac , TelnetParser seChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
seChar
	^ Character value: 240.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
special
	^ TelnetParser submodule /
		TelnetParser do /
		TelnetParser dont /
		TelnetParser will /
		TelnetParser wont /
		TelnetParser nop /
		TelnetParser dm /
		TelnetParser brk /
		TelnetParser ip /
		TelnetParser ao /
		TelnetParser ayt /
		TelnetParser ec /
		TelnetParser el /
		TelnetParser ga.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
submodule
	^ TelnetParser sb , #any asParser star , TelnetParser se.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
will
	^ TelnetParser iac , TelnetParser willChar asParser , #any asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
willChar
	^ Character value: 252.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:56'!
wont
	^ TelnetParser iac , TelnetParser wontChar asParser , #any asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
wontChar
	^ Character value: 252.! !

TestCase subclass: #MudServerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Tests'!

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/16/2012 23:22'!
testStartStop
	|server|
	server := MudServer new.
	server start.
	self should: [server isStarted].
	self shouldnt: [server isStopped].
	server stop.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/12/2012 23:20'!
testState
	|server|
	server := MudServer new.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !
